﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Web.Mvc;

namespace MvcServiceExample.Models
{
    [DataContract]
    public class Book
    {
        [DataMember]
        public string Author { get; set; }
        [DataMember]
        public string AuthorLink { get; set; }
        [DataMember]
        public string Title { get; set; }
        [DataMember]
        public Shelf Shelf { get; set; }
        [DataMember]
        public Guid BarCodeId { get; set; }
    }

    [DataContract]
    public class Shelf
    {
        [DataMember]
        public int Isle { get; set; }
        [DataMember]
        public string Category { get; set; }
    }

    public class BookData
    {
        public List<Book> GetBooks(RequestContext context)
        {
            // Get list of books
            List<Book> books = new List<Book>();

            books.Add(new Book()
            {
                Author = "Aaron Lerch",
                AuthorLink = RouteTable.Routes.GetUrl(context, new { Controller = "Books", Action = "Author", Id = "Aaron Lerch" }),
                Title = "MVC Services",
                BarCodeId = Guid.NewGuid(),
                Shelf = new Shelf()
                {
                    Category = "Boring",
                    Isle = 1
                }
            });

            books.Add(new Book()
            {
                Author = "Scott Guthrie",
                AuthorLink = RouteTable.Routes.GetUrl(context, new { Controller = "Books", Action = "Author", Id = "Scott Guthrie" }),
                Title = "MVC Examples",
                BarCodeId = Guid.NewGuid(),
                Shelf = new Shelf()
                {
                    Category = "Interesting",
                    Isle = 1
                }
            });

            books.Add(new Book()
            {
                Author = "Scott Hanselman",
                AuthorLink = RouteTable.Routes.GetUrl(context, new { Controller = "Books", Action = "Author", Id = "Scott Hanselman" }),
                Title = "MVC Walkthroughs",
                BarCodeId = Guid.NewGuid(),
                Shelf = new Shelf()
                {
                    Category = "Interesting",
                    Isle = 2
                }
            });

            return books;
        }
    }
}
