﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Xml.Linq;
using System.Web.Mvc;

namespace MvcServiceLibrary
{
    public abstract class SerializedView : IView
    {
        public SerializedView()
        {
            // Default to a StatusCode of OK
            StatusCode = 200;
        }

        public int StatusCode { get; set; }

        public abstract string ContentType { get; }
        public abstract string GetContent(ViewContext viewContext);

        #region IView Members

        public void RenderView(ViewContext viewContext)
        {
            if (viewContext.ViewData != null)
            {
                try
                {
                    viewContext.HttpContext.Response.StatusCode = StatusCode;
                    viewContext.HttpContext.Response.ContentType = ContentType;
                    viewContext.HttpContext.Response.Write(GetContent(viewContext));
                }
                catch (System.Runtime.Serialization.SerializationException serializationEx)
                {
                    viewContext.HttpContext.Response.SetStatusServerError(serializationEx.Message);
                }
            }
        }

        #endregion
    }
}
